'use strict'

var Analytics = require('@segment/analytics.js-core').constructor
var integration = require('@segment/analytics.js-integration')
var tester = require('@segment/analytics.js-integration-tester')
var sandbox = require('@segment/clear-env')
var Quora = require('../lib/')

describe('Quora', function () {
  var analytics
  var quora
  var options = {
    writeKey: '015c7f4e514b4b61b643e15c1f5dd82d'
  }

  beforeEach(function () {
    analytics = new Analytics()
    quora = new Quora(options)
    analytics.use(Quora)
    analytics.use(tester)
    analytics.add(quora)
  })

  afterEach(function () {
    analytics.restore()
    analytics.reset()
    quora.reset()
    sandbox()
  })

  it('should have the right settings', function () {
    analytics.compare(Quora, integration('Quora Conversion Pixel')
      .option('writeKey', ''))
  })

  describe('before loading', function () {
    beforeEach(function () {
      analytics.stub(quora, 'load')
    })

    describe('#initialize', function () {
      it('should call #load', function () {
        analytics.initialize()
        analytics.page()
        analytics.called(quora.load)
      })
    })
  })

  describe('loading', function () {
    it('should load', function (done) {
      analytics.load(quora, done)
    })
  })
})
